#include "MQBasePlugin.h"

// CNX
class SetLocalAxis : public MQObjectPlugin
{
public:
	SetLocalAxis();
	virtual ~SetLocalAxis();

	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	virtual const char *GetPlugInName(void);
	virtual const char *EnumString(int index);
	virtual BOOL Execute(int index, MQDocument doc);

	enum mode_t {
		none,
		selV, selO, //selcopy,
		rotateL, rotateN, rotateV, rotateC, //rotatecopy,
		copy,
		axisX, axisY, axisZ,
		mirrorX, mirrorY, mirrorZ,
		storeClip, restoreClip,
		locclear
	};

	BOOL main(MQDocument doc);

	int posX;
	int posY;

private:
	int m_mode;
	int m_setto;
	UINT m_targetobj;
	bool m_transform;
	bool m_global;
	bool m_copyR;
	bool m_copyS;
	bool m_copyT;

	BOOL trans_vertex(cmq::CMQDocument &doc, cmq::CMQObject &cur, bool selected = true);
//	BOOL trans_copy(cmq::CMQDocument &doc, cmq::CMQObject &cur);
	BOOL rotate_line(cmq::CMQDocument &doc, cmq::CMQObject &cur);
	BOOL rotate_normal(cmq::CMQDocument &doc, cmq::CMQObject &cur);
	BOOL rotate_vertex(cmq::CMQDocument &doc, cmq::CMQObject &cur);
	BOOL rotate_camera(cmq::CMQDocument &doc, cmq::CMQObject &cur);
//	BOOL rotate_copy(cmq::CMQDocument &doc, cmq::CMQObject &cur);
	BOOL rotateaxis(cmq::CMQDocument &doc, cmq::CMQObject &cur);
	BOOL mirroraxis(cmq::CMQDocument &doc, cmq::CMQObject &cur);
	BOOL copylocal(cmq::CMQDocument &doc, cmq::CMQObject &cur);

	BOOL storeclicpboard(cmq::CMQDocument &doc, cmq::CMQObject &cur);
	BOOL restoreclicpboard(cmq::CMQDocument &doc, cmq::CMQObject &cur);
	BOOL clearlocal(cmq::CMQDocument &doc, cmq::CMQObject &cur);

	void translateobj(cmq::CMQObject &obj, MQPoint trans);
	void rotateobj(cmq::CMQObject &obj, MQMatrix r, bool move = false);
	void setrotate(cmq::CMQObject &obj, MQPoint &vec);

	void setClipboardText(const std::string &s);
	std::string getClipboardText(void);

	BOOL callDialog(MQDocument doc);
	void loadSetting();
	void saveSetting();
};

class SetLocalAxisDialog : public MQDialog
{
public:
	SetLocalAxisDialog(MQWindowBase& parent, SetLocalAxis *plugin);
	~SetLocalAxisDialog() {}
	void listup(MQDocument doc_, UINT targetuid = -1);

	SetLocalAxis *m_pPlugin;

private:
	int mode;

	MQButton *m_button_transvert;
	MQButton *m_button_transobject;

	MQButton *m_button_rotateline;
	MQButton *m_button_rotatenormal;
	MQButton *m_button_rotatevert;
	MQButton *m_button_rotatecamera;
	MQButton *m_button_rotateobject;

	MQButton *m_button_copy;
	MQCheckBox *m_check_copyR;
	MQCheckBox *m_check_copyS;
	MQCheckBox *m_check_copyT;

	MQComboBox *m_combo_targetobj;

	MQButton *m_button_rotateaxisX;
	MQButton *m_button_rotateaxisY;
	MQButton *m_button_rotateaxisZ;

	MQButton *m_button_mirroraxisX;
	MQButton *m_button_mirroraxisY;
	MQButton *m_button_mirroraxisZ;
	MQCheckBox *m_check_global;

	MQButton *m_button_store;
	MQButton *m_button_restore;

	MQButton *m_button_clear;

	MQRadioButton *m_radio_setY;
	MQRadioButton *m_radio_setX;

	MQCheckBox *m_check_transform;

	BOOL check(MQWidgetBase *sender, MQDocument doc);
	BOOL click(MQWidgetBase *sender, MQDocument doc);
	BOOL radio(MQWidgetBase *sender, MQDocument doc);
	BOOL radioevent(MQWidgetBase *sender, MQDocument doc);
	BOOL keyevent(MQWidgetBase *sender, MQDocument doc, MQWidgetKeyParam& param);

	friend class SetLocalAxis;
};
